//
// DungeonQuest Hero Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-hero-front-sheet-template", "dungeonquest/templates/dq-hero-front.jp2",
	"dungeonquest-hero-back-sheet-template", "dungeonquest/templates/dq-hero-back.jp2",

	"dungeonquest-hero-portrait-template", "dungeonquest/portraits/image_1.jpg",
	"dungeonquest-hero-portrait-clip-region", "95,125,370,365",
	"dungeonquest-hero-portrait-scale", ".912",
	"dungeonquest-hero-portrait-panx", "0",
	"dungeonquest-hero-portrait-pany", "0",

	"dungeonquest-hero-title-region", "425,25,215,65",
	"dungeonquest-hero-text-region", "525,150,210,410"

//	"dungeonquest-hero-life-region", "656,52,75,50",
//	"dungeonquest-hero-strength-region", "34,354,60,50",	
//	"dungeonquest-hero-agility-region", "74,433,60,50",
//	"dungeonquest-hero-agility-region", "74,413,60,60",
//	"dungeonquest-hero-armor-region", "144,489,60,50",	
//	"dungeonquest-hero-luck-region", "231,518,60,50"
	
)

var heroBackgroundBlue = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-blue.jp2", true );
var heroBackgroundBrown = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-brown.jp2", true );
var heroBackgroundGreen = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-green.jp2", true );
var heroBackgroundOlive = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-olive.jp2", true );
//var heroBackgroundPurple = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-purple.jp2", true );
var heroBackgroundRed = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-red.jp2", true );
var heroBackgroundYellow = Image.fetchImageResource( "dungeonquest/templates/dq-hero-colour-yellow.jp2", true );

var b01 = Image.fetchImageResource( "dungeonquest/elements/b01.png", true );
var b02 = Image.fetchImageResource( "dungeonquest/elements/b02.png", true );
var b03 = Image.fetchImageResource( "dungeonquest/elements/b03.png", true );
var b04 = Image.fetchImageResource( "dungeonquest/elements/b04.png", true );
var b05 = Image.fetchImageResource( "dungeonquest/elements/b05.png", true );
var b06 = Image.fetchImageResource( "dungeonquest/elements/b06.png", true );
var b07 = Image.fetchImageResource( "dungeonquest/elements/b07.png", true );
var b08 = Image.fetchImageResource( "dungeonquest/elements/b08.png", true );
var b09 = Image.fetchImageResource( "dungeonquest/elements/b09.png", true );
var b10 = Image.fetchImageResource( "dungeonquest/elements/b10.png", true );
var b11 = Image.fetchImageResource( "dungeonquest/elements/b11.png", true );
var g01 = Image.fetchImageResource( "dungeonquest/elements/g01.png", true );
var g02 = Image.fetchImageResource( "dungeonquest/elements/g02.png", true );
var g03 = Image.fetchImageResource( "dungeonquest/elements/g03.png", true );
var g04 = Image.fetchImageResource( "dungeonquest/elements/g04.png", true );
var g05 = Image.fetchImageResource( "dungeonquest/elements/g05.png", true );
var g06 = Image.fetchImageResource( "dungeonquest/elements/g06.png", true );
var g07 = Image.fetchImageResource( "dungeonquest/elements/g07.png", true );
var g08 = Image.fetchImageResource( "dungeonquest/elements/g08.png", true );
var g09 = Image.fetchImageResource( "dungeonquest/elements/g09.png", true );
var g10 = Image.fetchImageResource( "dungeonquest/elements/g10.png", true );
var g11 = Image.fetchImageResource( "dungeonquest/elements/g11.png", true );
var r01 = Image.fetchImageResource( "dungeonquest/elements/r01.png", true );
var r02 = Image.fetchImageResource( "dungeonquest/elements/r02.png", true );
var r03 = Image.fetchImageResource( "dungeonquest/elements/r03.png", true );
var r04 = Image.fetchImageResource( "dungeonquest/elements/r04.png", true );
var r05 = Image.fetchImageResource( "dungeonquest/elements/r05.png", true );
var r06 = Image.fetchImageResource( "dungeonquest/elements/r06.png", true );
var r07 = Image.fetchImageResource( "dungeonquest/elements/r07.png", true );
var r08 = Image.fetchImageResource( "dungeonquest/elements/r08.png", true );
var r09 = Image.fetchImageResource( "dungeonquest/elements/r09.png", true );
var r10 = Image.fetchImageResource( "dungeonquest/elements/r10.png", true );
var r11 = Image.fetchImageResource( "dungeonquest/elements/r11.png", true );
var r12 = Image.fetchImageResource( "dungeonquest/elements/r12.png", true );
var r13 = Image.fetchImageResource( "dungeonquest/elements/r13.png", true );
var r14 = Image.fetchImageResource( "dungeonquest/elements/r14.png", true );
var r15 = Image.fetchImageResource( "dungeonquest/elements/r15.png", true );
var r16 = Image.fetchImageResource( "dungeonquest/elements/r16.png", true );
var r17 = Image.fetchImageResource( "dungeonquest/elements/r17.png", true );
var r18 = Image.fetchImageResource( "dungeonquest/elements/r18.png", true );
var r19 = Image.fetchImageResource( "dungeonquest/elements/r19.png", true );
var r20 = Image.fetchImageResource( "dungeonquest/elements/r20.png", true );
var y01 = Image.fetchImageResource( "dungeonquest/elements/y01.png", true );
var y02 = Image.fetchImageResource( "dungeonquest/elements/y02.png", true );
var y03 = Image.fetchImageResource( "dungeonquest/elements/y03.png", true );
var y04 = Image.fetchImageResource( "dungeonquest/elements/y04.png", true );
var y05 = Image.fetchImageResource( "dungeonquest/elements/y05.png", true );
var y06 = Image.fetchImageResource( "dungeonquest/elements/y06.png", true );
var y07 = Image.fetchImageResource( "dungeonquest/elements/y07.png", true );
var y08 = Image.fetchImageResource( "dungeonquest/elements/y08.png", true );
var y09 = Image.fetchImageResource( "dungeonquest/elements/y09.png", true );
var y10 = Image.fetchImageResource( "dungeonquest/elements/y10.png", true );
var y11 = Image.fetchImageResource( "dungeonquest/elements/y11.png", true );

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.PLAIN_BACK;
	diy.frontTemplateKey = "dungeonquest-hero-front-sheet";
	diy.backTemplateKey = "dungeonquest-hero-back-sheet";
	diy.portraitKey = "dungeonquest-hero";

	diy.name = "<++ U>gly the <++ O>gre";
	diy.comment = "Here we go again...";
	$SpecialText = "When you draw a Dungeon card, you may choose "
	               + "to hit it with your hammer before you flip it "
	               + "over.\n "
	               + "\n"
	               + "If it is a monster, its Attack value is reduced by 1.\n"
	               + "\n"
	               + "If it is treasure, it is destroyed and must be discarded.\n"
	               + "\n"
	               + "<i>You are never alone with a hammer!</i>\n"
	$Background = "Red";	               
	$Life = "13";		
	$Strength = "6";
	$Agility = "2";		
	$Armor = "5";
	$Luck = "4";		

}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	
	
	var backgroundCombo = comboBox( [	
		"Blue",
		"Brown",		
		"Green",
		"Olive",
//		"Purple",
		"Red",
		"Yellow"
	] );
	
	var attr1Panel = new Grid();
	attr1Panel.place(
		"Life", "gap unrel, wrap"
	);	
	
	var attr1Keys = [ "Life" ];
	for( var i=0; i<1; ++i ) {
		var attr1Combo = comboBox( [ "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20" ] );
		attr1Panel.place( attr1Combo, "growx, width pref+20lp" + (i > 0 ? ",gap unrel" : "") );
		bindings.add( attr1Keys[i], attr1Combo, [0] );
	}
	
	var attr2Panel = new Grid();
	attr2Panel.place(
		"Strength", "", "Agility", "gap unrel", "Armor", "gap unrel", "Luck", "gap unrel, wrap"
	);	
	
	var attr2Keys = [ "Strength", "Agility", "Armor", "Luck" ];
	for( var i=0; i<4; ++i ) {
		var attr2Combo = comboBox( [ "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11" ] );
		attr2Panel.place( attr2Combo, "growx, width pref+20lp" + (i > 0 ? ",gap unrel" : "") );
		bindings.add( attr2Keys[i], attr2Combo, [0] );
	}	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Background", "split", backgroundCombo, "width pref+20lp, wrap",			
		attr1Panel, "span, growx, wrap",
		attr2Panel, "span, growx, wrap",	
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );
	bindings.add( "Background", backgroundCombo, [0] );	
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, lifeBox, staminaBox, attributeBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 10 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 9 );	
//	specialTextBox.setReplacementForTag(
//		"hr", "<image res://dungeonquest/hero-divider.png 1.853333in>"
//	);
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_TOP|specialTextBox.LAYOUT_LEFT;
	
	lifeBox = createNumberBox( sheet );
    lifeBox.defaultStyle.add( SIZE, 25 );		
	attributeBox = createNumberBox( sheet );
    attributeBox.defaultStyle.add( SIZE, 20 );	

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		sheet.paintPortrait( g );	
		
		if( $Background == "Blue" ) {
	    heroBackground = heroBackgroundBlue;     
        }
        else if( $Background == "Brown" ) {
	    heroBackground = heroBackgroundBrown;     
        }
		else if( $Background == "Green" ) {
	    heroBackground = heroBackgroundGreen;    	      	    
        }        
        else if( $Background == "Olive" ) {
	    heroBackground = heroBackgroundOlive;	  	
        }  
//      else if( $Background == "Purple" ) {
//	    heroBackground = heroBackgroundPurple;		  	
//      } 	
        else if( $Background == "Red" ) {
	    heroBackground = heroBackgroundRed;	  	
        }  
        else if( $Background == "Yellow" ) {
	    heroBackground = heroBackgroundYellow;		  	
        } 
		g.drawImage( heroBackground, 0, 0, null );		
		
		sheet.paintTemplateImage( g );
			
		g.setPaint( Color.BLACK );
		
//		titleBox.markupText = "<b>" + diy.name + "</b>";
		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-hero-title") );

		specialTextBox.markupText = MACROS + $SpecialText;
		specialTextBox.draw( g, settings.getRegion("dungeonquest-hero-text") );	
		
   		var lifeValue;
		if( $Life == "1" ) {
        lifeValue = r01;
        }
		else if( $Life == "2" ) {
        lifeValue = r02;
        } 
		else if( $Life == "3" ) {
        lifeValue = r03;
        } 
		else if( $Life == "4" ) {
        lifeValue = r04;
        }
		else if( $Life == "5" ) {
        lifeValue = r05;
        } 
		else if( $Life == "6" ) {
        lifeValue = r06;
        } 
		else if( $Life == "7" ) {
        lifeValue = r07;
        } 
		else if( $Life == "8" ) {
        lifeValue = r08;
        }
		else if( $Life == "9" ) {
        lifeValue = r09;
        } 
		else if( $Life == "10" ) {
        lifeValue = r10;
        } 	
		else if( $Life == "11" ) {
        lifeValue = r11;
        }
		else if( $Life == "12" ) {
        lifeValue = r12;
        } 
		else if( $Life == "13" ) {
        lifeValue = r13;
        } 
		else if( $Life == "14" ) {
        lifeValue = r14;
        }
		else if( $Life == "15" ) {
        lifeValue = r15;
        } 
		else if( $Life == "16" ) {
        lifeValue = r16;
        } 
		else if( $Life == "17" ) {
        lifeValue = r17;
        } 
		else if( $Life == "18" ) {
        lifeValue = r18;
        }
		else if( $Life == "19" ) {
        lifeValue = r19;
        } 
		else if( $Life == "20" ) {
        lifeValue = r20;
        }

   		var strengthValue;
		if( $Strength == "1" ) {
        strengthValue = r01;
        }
		else if( $Strength == "2" ) {
        strengthValue = r02;
        } 
		else if( $Strength == "3" ) {
        strengthValue = r03;
        } 
		else if( $Strength == "4" ) {
        strengthValue = r04;
        }
		else if( $Strength == "5" ) {
        strengthValue = r05;
        } 
		else if( $Strength == "6" ) {
        strengthValue = r06;
        } 
		else if( $Strength == "7" ) {
        strengthValue = r07;
        } 
		else if( $Strength == "8" ) {
        strengthValue = r08;
        }
		else if( $Strength == "9" ) {
        strengthValue = r09;
        } 
		else if( $Strength == "10" ) {
        strengthValue = r10;
        } 	
		else if( $Strength == "11" ) {
        strengthValue = r11;
        }

   		var agilityValue;
		if( $Agility == "1" ) {
        agilityValue = g01;
        }
		else if( $Agility == "2" ) {
        agilityValue = g02;
        } 
		else if( $Agility == "3" ) {
        agilityValue = g03;
        } 
		else if( $Agility == "4" ) {
        agilityValue = g04;
        }
		else if( $Agility == "5" ) {
        agilityValue = g05;
        } 
		else if( $Agility == "6" ) {
        agilityValue = g06;
        } 
		else if( $Agility == "7" ) {
        agilityValue = g07;
        } 
		else if( $Agility == "8" ) {
        agilityValue = g08;
        }
		else if( $Agility == "9" ) {
        agilityValue = g09;
        } 
		else if( $Agility == "10" ) {
        agilityValue = g10;
        } 	
		else if( $Agility == "11" ) {
        agilityValue = g11;
        }

   		var armorValue;
		if( $Armor == "1" ) {
        armorValue = b01;
        }
		else if( $Armor == "2" ) {
        armorValue = b02;
        } 
		else if( $Armor == "3" ) {
        armorValue = b03;
        } 
		else if( $Armor == "4" ) {
        armorValue = b04;
        }
		else if( $Armor == "5" ) {
        armorValue = b05;
        } 
		else if( $Armor == "6" ) {
        armorValue = b06;
        } 
		else if( $Armor == "7" ) {
        armorValue = b07;
        } 
		else if( $Armor == "8" ) {
        armorValue = b08;
        }
		else if( $Armor == "9" ) {
        armorValue = b09;
        } 
		else if( $Armor == "10" ) {
        armorValue = b10;
        } 	
		else if( $Armor == "11" ) {
        armorValue = b11;
        }

   		var luckValue;
		if( $Luck == "1" ) {
        luckValue = y01;
        }
		else if( $Luck == "2" ) {
        luckValue = y02;
        } 
		else if( $Luck == "3" ) {
        luckValue = y03;
        } 
		else if( $Luck == "4" ) {
        luckValue = y04;
        }
		else if( $Luck == "5" ) {
        luckValue = y05;
        } 
		else if( $Luck == "6" ) {
        luckValue = y06;
        } 
		else if( $Luck == "7" ) {
        luckValue = y07;
        } 
		else if( $Luck == "8" ) {
        luckValue = y08;
        }
		else if( $Luck == "9" ) {
        luckValue = y09;
        } 
		else if( $Luck == "10" ) {
        luckValue = y10;
        } 	
		else if( $Luck == "11" ) {
        luckValue = y11;
        } 	656,17
		
		g.drawImage( lifeValue, 653, 17, 80, 80, null );
		g.drawImage( strengthValue, 34, 334, 60, 60, null );
		g.drawImage( agilityValue, 74, 413, 60, 60, null );
		g.drawImage( armorValue, 144, 469, 60, 60, null );
		g.drawImage( luckValue, 231, 498, 60, 60, null );	
		
//		g.setPaint( Color.RED );
//		
//		lifeBox.markupText = $Life;
//		lifeBox.draw( g, settings.getRegion("dungeonquest-hero-life") ); 
//
//		g.setPaint( Color.RED );	
//		
//		attributeBox.markupText = $Strength
//		attributeBox.drawAsSingleLine( g, settings.getRegion("dungeonquest-hero-strength") );	
//
//		g.setPaint( Color.GREEN );
//		
//		attributeBox.markupText = $Agility
//		attributeBox.drawAsSingleLine( g, settings.getRegion("dungeonquest-hero-agility") );	
//
//		g.setPaint( Color.BLUE );
//		
//		attributeBox.markupText = $Armor
//		attributeBox.drawAsSingleLine( g, settings.getRegion("dungeonquest-hero-armor") );		
//
//		g.setPaint( Color.YELLOW );
//		
//		attributeBox.markupText = $Luck
//		attributeBox.drawAsSingleLine( g, settings.getRegion("dungeonquest-hero-luck") );	
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {}
function paintBack( g, c, s ) {}

function onClear( diy ) {
	$SpecialText = "";
	$Life = "1";		
	$Strength = "1";
	$Agility = "1";
	$Armor = "1";
	$Luck = "1";
}

function onRead() {}
function onWrite() {}

// testDIYScript();